//*****************************************
//
//          www.kernelchip.ru
// Ke-USB24A ADC processing soft for Delphi
//
//               30 May 2008 
//
//*****************************************

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, mmsystem, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MyTimer: TTimer;
  uTimerID: word;
  i: word;
  CommHandle : hFile;
  DCB : TDCB;
  PortString: string;
  CommTimeOuts: TCOMMTIMEOUTS;

  p: PChar;
  BinBuf: array[0..1023] of Char;
  buffer: string;
  ADC_Res: array[0..64] of Char;
  ADCFloat: Double;
  CRbyte: Shortint;
  LFbyte: Shortint;
  NumberWritten : DWORD; 

implementation

{$R *.dfm}


procedure FNTimeCallBack(uTimerID, uMessage: UINT;dwUser, dw1, dw2: DWORD);stdcall;
begin

ReadFile(CommHandle, BinBuf, 128, NumberWritten, nil);
if(NumberWritten > 0) then
begin
p := BinBuf;
for i:=1 to NumberWritten do
begin
//**************
if (p^ = '#') then
begin
  if(StrLComp(p, PChar('#ADC,'), 4) = 0) then
  begin 
    p := p + 5;
    StrLCopy(ADC_Res, p, 4);
    ADCFloat := (StrToInt(ADC_Res)/1024)*5;
    Form1.Edit2.Text := FloatToStr(ADCFloat);
  end;
  inc(p);
end
//****************
end;
end;  
end; 


procedure TForm1.Button1Click(Sender: TObject);
begin
PortString := '\\.\COM' + Edit1.Text;   
CommHandle := CreateFile(PChar(PortString), GENERIC_READ or 
			GENERIC_WRITE, 0, nil, OPEN_EXISTING, 0, 0);

if (CommHandle = INVALID_HANDLE_VALUE) then
begin
  MessageDlg('Error. Can`t Open port', mtError, [mbOK], 0);
end
else
begin
  GetCommState(CommHandle, DCB);
  DCB.BaudRate  := CBR_9600; // FORMALLY, CONNECT BAUD DOESN`T MATTER (Virtual Com Port)
  DCB.Parity    := NOPARITY;
  DCB.ByteSize  := 8;
  DCB.StopBits  := OneStopBit;
  
  CommTimeOuts.ReadIntervalTimeout          := 0;
  CommTimeOuts.ReadTotalTimeoutMultiplier   := 0;
  CommTimeOuts.ReadTotalTimeoutConstant     := 1000;
  CommTimeOuts.WriteTotalTimeoutMultiplier  := 0;
  CommTimeOuts.WriteTotalTimeoutConstant    := 1000;
  SetCommTimeouts(CommHandle, CommTimeOuts);
  SetCommState(CommHandle, DCB);

  uTimerID := timeSetEvent(1000,0,@FNTimeCallBack,100,TIME_PERIODIC);

  CRbyte := 13; // HEX 0x0D
  LFbyte := 10; // HEX 0x0A
  buffer := '$KE,ADC,1' + Char(CRbyte) + Char(LFbyte);
  WriteFile(CommHandle, PChar(buffer)^, Length(buffer), NumberWritten, nil);

  MessageDlg('Port Open Ok', mtInformation, [mbOK], 0);
end 
end;

end.
